﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FlexGridDetailGrid_CRUD.Models;
using C1.Web.Mvc;
using C1.Web.Mvc.Serialization;
using System.Data.Entity;
using System.Data.Entity.Validation;

namespace FlexGridDetailGrid_CRUD.Controllers
{
    public class CustomerWithOrder :Customer
    {
        //public string CustomerID { get; set; }
        //public string CompanyName { get; set; }       
        //public string City { get; set; }       
        
        //public string Country { get; set; }
       
        public List<Order> Orders { get; set; }
        
    }
    public class HomeController : Controller
    {
       
        //Define data source for FlexGrid
        private C1NWindEntities db = new C1NWindEntities();

      
        public ActionResult Index()
        {
            return View();
        }
        //Instantiate a JSON request
        public ActionResult GridReadCustomer([C1JsonRequest] CollectionViewRequest<Customer> requestData)
        {
            return this.C1Json(CollectionViewHelper.Read(requestData, GetCustomers()));
        }
        private IEnumerable<Customer> GetCustomers()
        {
            List<Customer> customers = db.Customers.Take(10).ToList();
            //List<CustomerWithOrder> customerOrders = new List<CustomerWithOrder>();
            //foreach(var i in customers)
            //{
            //    customerOrders.Add(
            //        new CustomerWithOrder
            //        {
            //            CustomerID = i.CustomerID,
            //            CompanyName = i.CompanyName,
            //            Country = i.Country,
            //            City = i.City,
            //            Orders = db.Orders.Where(o => o.CustomerID == i.CustomerID).ToList()

            //        });
            //}
            //return customerOrders;
            return customers;
        }

        public ActionResult GridReadOrder(string customerID, [C1JsonRequest] CollectionViewRequest<Order> requestData)
        {
            var orders = db.Orders.Where(o => o.CustomerID == customerID);
            return this.C1Json(CollectionViewHelper.Read(requestData, orders));
        }

        //Instantiate a JSON request
        public ActionResult GridUpdateCustomer([C1JsonRequest]CollectionViewEditRequest<Customer> requestData)
        {
            return Update(requestData, db.Customers.Take(10));
        }
        private ActionResult Update<T>(CollectionViewEditRequest<T> requestData, IEnumerable<T> data) where T : class
        {
            return this.C1Json(CollectionViewHelper.Edit<T>(requestData, item =>
            {
                string error = string.Empty;
                bool success = true;
                try
                {
                    db.Entry(item as object).State = EntityState.Modified;
                    db.SaveChanges();
                }
                catch (DbEntityValidationException e)
                {
                    error = string.Join(",", e.EntityValidationErrors.Select(result =>
                    {
                        return string.Join(",", result.ValidationErrors.Select(err => err.ErrorMessage));
                    }));
                    success = false;
                }
                catch (Exception e)
                {
                    error = e.Message;
                    success = false;
                }
                return new CollectionViewItemResult<T>
                {
                    Error = error,
                    Success = success && ModelState.IsValid,
                    Data = item
                };
            }, () => data.ToList<T>()));
        }


        //Instantiate a JSON request

        public ActionResult GridUpdateOrder(string customerID, [C1JsonRequest]CollectionViewEditRequest<Order> requestData)
        {
            var orders = db.Orders.Where(o => o.CustomerID == customerID);
            return UpdateOrder(requestData, orders);
        }
        private ActionResult UpdateOrder<T>(CollectionViewEditRequest<T> requestData, IEnumerable<T> data) where T : class
        {
            return this.C1Json(CollectionViewHelper.Edit<T>(requestData, item =>
            {
                string error = string.Empty;
                bool success = true;
                try
                {
                    db.Entry(item as object).State = EntityState.Modified;
                    db.SaveChanges();
                }
                catch (DbEntityValidationException e)
                {
                    error = string.Join(",", e.EntityValidationErrors.Select(result =>
                    {
                        return string.Join(",", result.ValidationErrors.Select(err => err.ErrorMessage));
                    }));
                    success = false;
                }
                catch (Exception e)
                {
                    error = e.Message;
                    success = false;
                }
                return new CollectionViewItemResult<T>
                {
                    Error = error,
                    Success = success && ModelState.IsValid,
                    Data = item
                };
            }, () => data.ToList<T>()));
        }
        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}